/***********************
Pager for Windows Version 0.1
2010/07/24
Written by PhilKll...
OpenDidjConnect@project-notes.com

Pager is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Pager is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Pager.  If not, see <http://www.gnu.org/licenses/>.
***********************/

/* OpenLX_USB_Boot.cpp : Defines the entry point for the console application.

get options
http://www.codeproject.com/kb/cpp/xgetopt.aspx

*/
#include <tchar.h>
#include <stdio.h>
#include <memory.h>
#include <conio.h>
#include <string.h>
#include <cctype>
#include <ctype.h>
#include <cstdlib>

#include <iostream>
#include <fstream>


#include "open_disk_by_id.h"
#include "scsi_cdb.h"
#include "XGetopt.h"
using namespace std;
char version[4] = "0.1";

/*
********************************************************************************************
* FUNCTIONS
* 
********************************************************************************************
*/
// print help information
void print_help(void){
      printf("\nUsage pager.exe -f <file name>\n\n \
Example: pager.exe -f surgeon.cbf  \
\n\tWill send a file to an Explorer in USB boot mode.\n \
Help (-h): \
\n\t Show this help file.\n\n \
Written by PhilKll... irc.freenode.org #Didj\n");
  
  }
// Get command line args and print help or send file

/*
********************************************************************************************
* MAIN PROGRAM LOOP
*
********************************************************************************************
*/
// accept command line arguements -d <drive_letter> -c <command> -h [help]
int main(int argc, char *argv[])
{
	// Pager Version Number and  header Title
	printf("\nOpenLX Pager %s\n\n",version);


	//http://www.cplusplus.com/doc/tutorial/files/
	ofstream::pos_type file_size;
	char * mem_block = NULL;
	ifstream  file_handle;

	HANDLE device_handle = NULL;

	// file info
	// size of packets that will be sent
	const int packet_size = 16384;
	// total number to send
	int packet_amount = 0;
	// number of packets sent
	int packet_tracker = 0;
	// toggle LBA after first packet
	// for compliance with "magic number"
	int lba_toggle = 0;
	// data buffer to send
	UCHAR data_buffer[packet_size];
	// position in mem_block
	int mem_tracker = 0;

	// configure cdb for write10
	CDB_WRITE10 cdb = {0};
	cdb.OperationCode = 0x2A;	// write10
	cdb.TransferLength0 = 0x00;
	cdb.TransferLength1 = 0x00;
 
	// SCSI_PASS_THROUGH vars
	unsigned char cmd[sizeof(SCSI_PASS_THROUGH_DIRECT)+96] = {0};
	SCSI_PASS_THROUGH_DIRECT *pcmd;

	// configure cdb for verify
	CDB_VERIFY cdbv = {0};
	cdbv.OperationCode = 0x2F;	// verify10

	// SCSI_PASS_THROUGH vars
	unsigned char cmdv[sizeof(SCSI_PASS_THROUGH_DIRECT)+96] = {0};
	SCSI_PASS_THROUGH_DIRECT *pcmdv;

	// common
	DWORD returned;
	DWORD err;
	BOOL bRet;


	// if no options, print help
	if(argc < 2){
		print_help();
		return -1;
	}


	int e;
	// call Xgetopt.cpp to parse command line options
	while ((e = getopt(argc, argv, ("hf:"))) != EOF)
	{		
		switch (e)
		{
			case ('h'):
				print_help();
				return -1;				
				break;
			case ('f'):
				file_handle.open (optarg,ios::out|ios::binary|ios::ate);
				// open \PhysicalDriveX with vendor and product id of
				device_handle = open_device_by_id("Leapfrog","LeapsterExplorer");
				// none found exit
				if(device_handle == NULL)
				{
					printf("Explorer not found, is it hooked up?\n");
					return 0;
				}

				// open file to send, put in mem_block and close
				if (file_handle.is_open())
				{
					file_size = file_handle.tellg();
					mem_block = new char[file_size];
					file_handle.seekg(0,ios::beg);
					file_handle.read(mem_block,file_size);
					file_handle.close();	
				}

				// get number of packets to send
				packet_amount = file_size/packet_size;

				// loop for sending packets
				while(packet_tracker < packet_amount){

					// load packet from mem_block
					// keeping track of position in mem_block
					for(int i = 0;i<packet_size;i++)
					{
						data_buffer[i] = mem_block[mem_tracker];
						mem_tracker++;	
					}	

					// increment packet number sent
					packet_tracker++;

					// progress report
					printf("\rSending Packet:%i",packet_tracker);

					// configure SCSI_PASS_THROUGH_DIRECT for this packet
					pcmd = (SCSI_PASS_THROUGH_DIRECT *) cmd;

					// Copy the CDB to the SCSI_PASS_THROUGH structure
					memcpy(pcmd->Cdb, &cdb, sizeof(cdb));
					pcmd->DataTransferLength = sizeof(data_buffer);
					pcmd->DataBuffer = data_buffer;
					pcmd->DataIn = SCSI_IOCTL_DATA_OUT;
					pcmd->CdbLength = sizeof(cdb);
					pcmd->Length = sizeof(SCSI_PASS_THROUGH_DIRECT);
					pcmd->SenseInfoLength = sizeof(cmd) - sizeof(SCSI_PASS_THROUGH_DIRECT);
					pcmd->SenseInfoOffset = sizeof(SCSI_PASS_THROUGH_DIRECT);
					pcmd->TimeOutValue = 6000;
					//http://msdn.microsoft.com/en-us/library/aa363216%28VS.85%29.aspx

					// send packet to device
					bRet = DeviceIoControl(
						device_handle, 
						IOCTL_SCSI_PASS_THROUGH_DIRECT, 
						(LPVOID)&cmd, 
						sizeof(cmd), 
						(LPVOID)&cmd, 
						sizeof(cmd), 
						&returned, 
						NULL);

					// check for errors
					// http://msdn.microsoft.com/en-us/library/ms681381(v=VS.85).aspx
					err = ::GetLastError();
					if (err != ERROR_SUCCESS)
					{
						printf("\ncarry_cdb_no_buff(): last error = %08X\n", err);
						// close device_handle
						::CloseHandle(device_handle);
						return 0;
					}
	
					// first packet sent toggle LBA to 1
					// magic number should have been set now
					if(lba_toggle != 1)
					{
						cdb.LBA0 = 0x01 ;
						lba_toggle = 1;
					}
				}// end while
	
				// configure SCSI_PASS_THROUGH_DIRECT for verify
				// which will tell LX to boot data sent
				pcmdv = (SCSI_PASS_THROUGH_DIRECT *) cmdv;

				// Copy the CDB to the SCSI_PASS_THROUGH structure
				memcpy(pcmdv->Cdb, &cdbv, sizeof(cdbv));
				pcmdv->DataTransferLength = 0;
				pcmdv->DataIn = SCSI_IOCTL_DATA_IN;
				pcmdv->CdbLength = sizeof(cdbv);
				pcmdv->Length = sizeof(SCSI_PASS_THROUGH_DIRECT);
				pcmdv->SenseInfoLength = sizeof(cmdv) - sizeof(SCSI_PASS_THROUGH_DIRECT);
				pcmdv->SenseInfoOffset = sizeof(SCSI_PASS_THROUGH_DIRECT);
				pcmdv->TimeOutValue = 6000;
				//http://msdn.microsoft.com/en-us/library/aa363216%28VS.85%29.aspx
					
				// send verify10 command	
				bRet = DeviceIoControl(
					device_handle, 
					IOCTL_SCSI_PASS_THROUGH_DIRECT, 
					(LPVOID)&cmdv, 
					sizeof(cmdv), 
					(LPVOID)&cmdv, 
					sizeof(cmdv), 
					&returned, 
					NULL);

				// check for errors
				// http://msdn.microsoft.com/en-us/library/ms681381(v=VS.85).aspx
				err = ::GetLastError();
				if (err != ERROR_SUCCESS)
				{
					printf("\ncarry_cdb_no_buff(): last error = %08X\n", err);
					// close device_handle
					::CloseHandle(device_handle);
					return 0;
				}				
				
				// all done
				printf("\nFinished!\n");	
				
				// delete mem_block
				delete[] mem_block;
				// close device_handle
				::CloseHandle(device_handle);
				return 0;
				break;

			default:
				printf("\nError: Missing a value or command.\n");
		}
	}
// all done why did it get here? 
	return 0;
}




