/***********************
Pager for Windows Version 0.1
2010/07/24
Written by PhilKll...
OpenDidjConnect@project-notes.com

Pager is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Pager is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with Pager.  If not, see <http://www.gnu.org/licenses/>.
***********************/
#include <tchar.h>
#include <stdio.h>
#include <memory.h>
#include <conio.h>
#include <string.h>
#include <cctype>
#include <ctype.h>
#include <cstdlib>
#include "open_disk_by_id.h"
#include "scsi_cdb.h"
/*
********************************************************************************************
* CDB INQUIRY
*
********************************************************************************************
*/

// call inquiry command function
bool device_inquire(HANDLE device, char vendor_name[50], char product_name[50])
{
	// initialize structures
	CDB_INQUIRY inquiry = {0};
	DATA_INQUIRY data = {0};
	// set return buffer size
	inquiry.AllocationLength = sizeof(data);
	// set SCSI Command value
	inquiry.OperationCode6 = 0x12;
	// send command
	if (!cdb_custom_scsi_command_return(device, &inquiry, sizeof(inquiry), &data, sizeof(data), SCSI_IOCTL_DATA_IN))
	{
		printf("could not inquire!\n");
		return 0;
	}
  			// string buffer
			char vendor_id[50] = {0};
			// string buffer
			char product_id[50] = {0};
			// string buffer
			char revision_id[50] = {0};

			int i;
			// copy and terminate string
			strncpy_s(vendor_id, data.vendor_id, i = sizeof(data.vendor_id));
			vendor_id[i] = 0;
			strncpy_s(product_id, data.product_id, i = sizeof(data.product_id));
			product_id[i] = 0;
			strncpy_s(revision_id, data.product_revision_level , i = sizeof(data.product_revision_level));
			revision_id[i] = 0;
			
			// check if device vendor is LeapFrog and Product LeapsterExplorer or not return 0 if fail
			if(strcmp(_T(vendor_name),vendor_id)!=0 || strcmp(_T(product_name),product_id)!=0){
				return 0;
			}
			printf(
				"%s: %s Info:\n"
				"-----------\n",vendor_id, product_id);
			// print vendor id
			printf("Vendor ID: %s\n", vendor_id);
			// get product id

			// print product id
			printf("Product ID: %s\n", product_id);

			// print prod rev number
			printf("Product Revision Level: %s\n", revision_id);
			return 1;
}

// iterate thru \PhysicalDrive[x]
void* open_device_by_id(char vendor_name[50], char product_name[50])
{
	// for holding drive string for createfile
	char device_name[50];
	HANDLE device_handle = NULL;
	for(int i = 0; i<10;i++)
	{
		// set device name
		sprintf_s(device_name,sizeof(device_name), "\\\\.\\PhysicalDrive%i",i);
		// open device
		device_handle = ::CreateFile(device_name, 
			GENERIC_READ | GENERIC_WRITE, 
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			NULL,OPEN_EXISTING,0,0);
		//device_handle = device_hnd;
		// check if device was opened if not, no more devices
		if (device_handle == NULL || device_handle == INVALID_HANDLE_VALUE)
		{
			return NULL;
		}

		// Check for successful inquiry, if so exit for loop
		if(device_inquire(device_handle,vendor_name,product_name))
		{			
			printf("\nOpening LX device file %s\n\n",device_name);
			return device_handle;
		}else{
			::CloseHandle(device_handle);
			device_handle = NULL;
		}
	}
	// should never get here
	printf("Explorer not found, is it hooked up?");
	return NULL;
}