
#include "scsi_cdb.h"
#include <tchar.h>
#include <stdio.h>
#include <memory.h>
#include <conio.h>
#include <string.h>
#include <cctype>
#include <ctype.h>
#include <cstdlib>
/*
********************************************************************************************
* CDB SENDS
*
********************************************************************************************
*/

// send command expecting a return value function
bool cdb_custom_scsi_command_return(HANDLE device, void *cdb, UCHAR cdb_length, void *buffer, DWORD buffer_length, int data_in)
{
  DWORD returned;

  // size of SCSI_PASS_THROUGH + 96 bytes for sense data
  unsigned char cmd[sizeof(SCSI_PASS_THROUGH_DIRECT) + 255] = {0};
  // shortcut to the buffer
  SCSI_PASS_THROUGH_DIRECT *pcmd = (SCSI_PASS_THROUGH_DIRECT *) cmd;

  // Copy the CDB to the SCSI_PASS_THROUGH structure
  memcpy(pcmd->Cdb, cdb, cdb_length);

  pcmd->DataBuffer = buffer;
  pcmd->DataTransferLength = buffer_length;
  pcmd->DataIn = data_in;
  pcmd->CdbLength = cdb_length;
  pcmd->Length = sizeof(SCSI_PASS_THROUGH_DIRECT);
  pcmd->SenseInfoLength = sizeof(cmd) - sizeof(SCSI_PASS_THROUGH_DIRECT);
  pcmd->SenseInfoOffset = sizeof(SCSI_PASS_THROUGH_DIRECT);
  pcmd->TimeOutValue = 6000;
//http://msdn.microsoft.com/en-us/library/aa363216%28VS.85%29.aspx
  BOOL bRet = DeviceIoControl(
    device, 
    IOCTL_SCSI_PASS_THROUGH_DIRECT, 
    (LPVOID)&cmd, 
    sizeof(cmd), 
    (LPVOID)&cmd, 
    sizeof(cmd), 
    &returned, 
    NULL);

#ifdef _DEBUG
  DWORD err = ::GetLastError();
  if (err != ERROR_SUCCESS)
  {
    printf("carry_cdb(): last error = %08X\n", err);
  }
#endif
  return bRet ? true : false;
}




