/***********************
OpenDidjConnect Version 1.3
2010/05/10
Written by PhilKll... irc.freenode.org #Didj

OpenDidjConnect is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 OpenDidjConnect is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with LCD.NET Framework.  If not, see <http://www.gnu.org/licenses/>.
***********************/


/* OpenDidjConnect.cpp : Defines the entry point for the console application.

get options
http://www.codeproject.com/kb/cpp/xgetopt.aspx

parts adapted from this
http://www.codeproject.com/KB/system/mydvdregion.aspx

Written by PhilKll... irc.freenode.org #Didj
*/

#include <windows.h>
#include <Ntddscsi.h>

bool cdb_custom_scsi_command_return(HANDLE, void *, UCHAR, void *, DWORD, int);
// If this was not defined we should also assume that some structs are not defined as well
#ifndef IOCTL_SCSI_PASS_THROUGH_DIRECT

#define IOCTL_SCSI_PASS_THROUGH_DIRECT 0x4D014
#define SCSI_IOCTL_DATA_OUT          0
#define SCSI_IOCTL_DATA_IN           1
#define SCSI_IOCTL_DATA_UNSPECIFIED  2

// define if necessary
typedef struct _SCSI_PASS_THROUGH_DIRECT 
{
//http://msdn.microsoft.com/en-us/library/ff565346.aspx
  USHORT Length;
  UCHAR ScsiStatus;
  UCHAR PathId;
  UCHAR TargetId;
  UCHAR Lun;
  UCHAR CdbLength;
  UCHAR SenseInfoLength;
  UCHAR DataIn;
  ULONG DataTransferLength;
  ULONG TimeOutValue;
  PVOID DataBuffer;
  ULONG SenseInfoOffset;
  UCHAR Cdb[16];
} SCSI_PASS_THROUGH_DIRECT, *PSCSI_PASS_THROUGH_DIRECT;

#endif

#pragma pack(1)





/*
********************************************************************************************
* CDB INQUIRY
*
********************************************************************************************
*/
// command structure
// SCSI INQUIRY Command
typedef struct _CDB_INQUIRY 
{
  UCHAR OperationCode6;    // 0x12 - SCSIOP_INQUIRY
  UCHAR Reserved1 : 5;
  UCHAR LogicalUnitNumber : 3;
  UCHAR PageCode;
  UCHAR IReserved;
  UCHAR AllocationLength;
  UCHAR Control;
} CDB_INQUIRY;

// data structure
typedef struct _DATA_INQUIRY
{
  UCHAR		preipheral_device_type : 5;
  UCHAR		peripheral_qualifier: 3;
  UCHAR		rsvrd : 7;
  UCHAR		rmb: 1;
  UCHAR		version;
  UCHAR		RESPONSE_DATA_FORMAT;				// 7 = AERC, 6 = Obsolete, 5 = NormACA, 4 = HiSup 3-0 = Response data format.
  // If ANSI Version = 0, this is ATAPI and bits 7-4 = ATAPI version.
  UCHAR		ADDITIONAL_LENGTH;					// Number of additional bytes available in inquiry data
  UCHAR		SCCSReserved;						// SCC-2 device flag and reserved fields
  UCHAR		flags1;								// First byte of support flags
  UCHAR		flags2;								// Second byte of support flags (Byte 7)
  char		vendor_id[8];
  char		product_id[16];
  char		product_revision_level[4];
} DATA_INQUIRY;


/*
********************************************************************************************
* CDB WRITE10
*
********************************************************************************************
*/
// command structure
// SCSI INQUIRY Command
typedef struct _CDB_WRITE10 
{
  UCHAR OperationCode;    // 0x12 - SCSIOP_INQUIRY
  UCHAR Lun : 3;
  UCHAR DPO : 1;
  UCHAR FUA : 1;
  UCHAR EBP : 1;
  UCHAR Reserved0 : 1;
  UCHAR RelAdr : 1;
  UCHAR LBA3;
  UCHAR LBA2;
  UCHAR LBA1;
  UCHAR LBA0;
  UCHAR Reserved1;
  UCHAR TransferLength1;
  UCHAR TransferLength0;
  UCHAR Control;
} CDB_WRITE10;

// data structure
typedef struct _DATA_WRITE10
{
  UCHAR byte0; 
  UCHAR byte1;
  UCHAR byte2;
  UCHAR byte3;
  UCHAR byte4;
  UCHAR byte5;
} DATA_WRITE10;


/*
********************************************************************************************
* CDB VERIFY10
*
********************************************************************************************
*/
// command structure
// SCSI INQUIRY Command
typedef struct _CDB_VERIFY 
{
  UCHAR OperationCode;    // 0x12 - SCSIOP_INQUIRY
  UCHAR Lun : 3;
  UCHAR DPO : 1;
  UCHAR FUA : 1;
  UCHAR EBP : 1;
  UCHAR Reserved0 : 1;
  UCHAR RelAdr : 1;
  UCHAR LBA3;
  UCHAR LBA2;
  UCHAR LBA1;
  UCHAR LBA0;
  UCHAR Reserved1;
  UCHAR TransferLength1;
  UCHAR TransferLength0;
  UCHAR Control;
} CDB_VERIFY;

// data structure
typedef struct _DATA_VERIFY
{
  UCHAR byte0; 
  UCHAR byte1;
  UCHAR byte2;
  UCHAR byte3;
  UCHAR byte4;
  UCHAR byte5;
} DATA_VERIFY;




#pragma pack()